---
title: 'WebGLRenderingContext.uniformMatrix[234]fv()'
slug: Web/API/WebGLRenderingContext/uniformMatrix
tags:
  - API
  - Method
  - Reference
  - Uniform Variables
  - Uniforms
  - WebGL
  - WebGL API
  - WebGLRenderingContext
  - matrices
  - matrix
  - uniformMatrix2fv
  - uniformMatrix3fv
  - uniformMatrix4fv
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.uniformMatrix[234]fv()</code></strong> methods of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> specify matrix values for uniform variables.</p>

<p>The three versions of this method (<code>uniformMatrix2fv()</code>, <code>uniformMatrix3fv()</code>, and <code>uniformMatrix4fv()</code>) take as the input value 2-component, 3-component, and 4-component square matrices, respectively.  They are expected to have 4, 9 or 16 floats.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>WebGLRenderingContext</em>.uniformMatrix2fv(<em>location</em>, <em>transpose</em>, <em>value</em>);
<em>WebGLRenderingContext</em>.uniformMatrix3fv(<em>location</em>, <em>transpose</em>, <em>value</em>);
<em>WebGLRenderingContext</em>.uniformMatrix4fv(<em>location</em>, <em>transpose</em>, <em>value</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>location</code></dt>
 <dd>A {{domxref("WebGLUniformLocation")}} object containing the location of the uniform attribute to modify. The location is obtained using {{domxref("WebGLRenderingContext.getUniformLocation", "getUniformLocation()")}}.</dd>
 <dt><code>transpose</code></dt>
 <dd>A {{domxref("GLboolean")}} specifying whether to transpose the matrix. Must be <code>false</code>.</dd>
 <dt><code>value</code></dt>
 <dd>
 <p>A {{jsxref("Float32Array")}} or sequence of <code>GLfloat</code> values. The values are assumed to be supplied in column major order.</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code></p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.uniformMatrix2fv(loc, false, [2,1, 2,2]);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.10", "uniformMatrix")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glUniform.xml", "glUniform")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.uniformMatrix2fv")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.uniform()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.uniformMatrix()")}} – WebGL 2 versions of these methods.</li>
</ul>
